#ifndef OCEANSURFACE_H
#define OCEANSURFACE_H

#include <Inventor/SbLinear.h>
#include <Inventor/nodes/SoSeparator.h>

class Box;
class Grid;
class OceanShader;

class SoSensor;
class SoNodeSensor;
class SoPerspectiveCamera;

class OceanSurface : public SoSeparator {
public:
  OceanSurface(SbVec2s resolution, SbVec2f scales);
  void setCamera(SoPerspectiveCamera * camera);

  static void callback(void * closure, SoSensor * sensor);

private:
  Box * box;
  Grid * grid;
  OceanShader * shader;
  SoNodeSensor * sensor;
  SoPerspectiveCamera * camera;

  ~OceanSurface();
  void calculateCorners();
};

#endif
