#include "Ocean.h"
#include "WaveField.h"

#include <Inventor/Qt/SoQt.h>
#include <Inventor/Qt/viewers/SoQtExaminerViewer.h>

int
main(int argc, char ** argv)
{
  // initialize application
  SoDB::init();
  WaveField::initClass();
  QWidget * mainwin = SoQt::init(argv[0]);

  // create ocean node
  Ocean * ocean = new Ocean;
  ocean->ref();

  // set up a viewer
  SoQtExaminerViewer * viewer = new SoQtExaminerViewer(mainwin);
  viewer->setBackgroundColor(SbColor(1.0f, 1.0f, 1.0f));
  viewer->setSize(SbVec2s(800, 500));
  viewer->setAutoClipping(false);
  viewer->setSceneGraph(ocean);
  viewer->show();

  // run the show
  SoQt::show(mainwin);
  SoQt::mainLoop();

  // clean up and exit
  delete viewer;
  ocean->unref();
  return 0;
}
