#ifndef UTIL_H
#define UTIL_H

#include <Inventor/SbBox.h>
#include <Inventor/SbLinear.h>

/*
  Get the viewing frustum in world space
  given the inverse camera transformation
*/
void getFrustum(SbVec4f v[8], SbMatrix & pmi);

/*
  Intersect viewing frustum with xy-plane +- (0, 0, d)
*/
bool getIntersections(SbVec3f intersections[2][12], SbVec4f v[8], float d);

/*
  Find screen-aligned bounding rectangle
*/
SbBox2f getBounds(SbVec3f intersections[2][12], SbMatrix & pm);

/*
  Get projection onto the xy-plane in world space
*/
void getCorners(SbVec4f c[4], SbBox2f & box, SbMatrix & pmi);

#endif
