uniform sampler2D sampler;

const int C = 0;
const int S = 1; // Use a (S+1)^2 mask

void main()
{
  vec2 texCoord = gl_TexCoord[0].st;
  const vec2 offset = vec2(1.0 / 640.0, 1.0 / 400.0);
  
  gl_FragColor = texture2D(sampler, texCoord);
  
  // smooth specified channel
  gl_FragColor[C] = 0.0;
  for (int j = -S; j <= S; j++) {
    for (int i = -S; i <= S; i++) {
      gl_FragColor[C] += texture2D(sampler, texCoord + 2.0 * vec2(i, j) * offset)[C];
    }
  }
  gl_FragColor[C] /= pow(float(2 * S + 1), 2.0);
}
