#ifndef SOLVER_H
#define SOLVER_H

class FramebufferObject;

class Solver {
public:
  float friction, g_spring, n_spring;

  Solver(int width, int height);
  ~Solver();

  void render();
  void update();

  void bind(int texture = -1);
  void clear();

  void startRendering(int mask = 0xF);
  void finishRendering();

private:
  int width, height, viewport[4];

  FramebufferObject *fbo;
  int buffer[4], src, dst, res, win, sampler;
  unsigned int tex[3], propagate, smooth;
  unsigned int passthrough_vert, propagate_frag, smooth_frag;

  void initShaders();
  void initTextures();
};

#endif
