#include "Box.h"

#include <Inventor/nodes/SoIndexedFaceSet.h>

Box::Box()
{
  // set up points
  SbVec3f points[] = {
    SbVec3f(-1, -1, -1),
    SbVec3f( 1, -1, -1),
    SbVec3f( 1,  1, -1),
    SbVec3f(-1,  1, -1),
    SbVec3f(-1, -1,  1),
    SbVec3f( 1, -1,  1),
    SbVec3f( 1,  1,  1),
    SbVec3f(-1,  1,  1)
  };

  // create coordinates
  coords = new SoCoordinate3;
  coords->point.setValues(0, 8, points);
  this->addChild(coords);

  // set up indices
  int32_t indices[] = {
    0, 1, 2, 3, -1,
    4, 7, 6, 5, -1,
    0, 3, 7, 4, -1,
    1, 5, 6, 2, -1,
    0, 4, 5, 1, -1,
    3, 2, 6, 7, -1
  };

  // create a face set for the box
  SoIndexedFaceSet * box = new SoIndexedFaceSet;
  box->coordIndex.setValues(0, 30, indices);
  this->addChild(box);
}
