#ifndef CPU_OCEANSURFACE_H
#define CPU_OCEANSURFACE_H

#include <Inventor/nodes/SoSeparator.h>

class Box;
class Grid;
class SoSensor;
class SoNodeSensor;
class SoPerspectiveCamera;

class CPU_OceanSurface : public SoSeparator {
public:
  CPU_OceanSurface(int width, int height);

  static void callback(void * closure, SoSensor * sensor);

  void setEnabled(bool enable);
  void setCamera(SoPerspectiveCamera * camera);

private:
  Box * box;
  Grid * grid;
  SoNodeSensor * sensor;
  SoPerspectiveCamera * camera;

  ~CPU_OceanSurface();
};

#endif
