#ifndef GPU_OCEANSURFACE_H
#define GPU_OCEANSURFACE_H

#include <Inventor/nodes/SoSeparator.h>

class Box;
class Grid;
class SoSensor;
class SoNodeSensor;
class SoPerspectiveCamera;

class SoVertexShader;
class SoFragmentShader;

class GPU_OceanSurface : public SoSeparator {
public:
  GPU_OceanSurface(int width, int height);

  static void callback(void * closure, SoSensor * sensor);

  void setEnabled(bool enable);
  void setCamera(SoPerspectiveCamera * camera);

private:
  Box * box;
  Grid * grid;
  SoNodeSensor * sensor;
  SoPerspectiveCamera * camera;

  SoVertexShader * vert;
  SoFragmentShader * frag;

  ~GPU_OceanSurface();
};

#endif
