#ifndef FRESNELMAP_H
#define FRESNELMAP_H

#include <Inventor/fields/SoMFFloat.h>
#include <Inventor/fields/SoSFShort.h>
#include <Inventor/nodes/SoTexture2.h>

class SoSensor;
class SoFieldSensor;

class FresnelMap : public SoTexture2 {
  SO_NODE_HEADER(FresnelMap);

public:
  SoSFShort samples;          // number of samples per reflectance function
  SoMFFloat refractiveRatios; // refractive ratios for the desired interfaces (air to water: 0.75)

  FresnelMap();
  static void initClass();

private:
  SoFieldSensor * sizesensor;
  SoFieldSensor * iorsensor;

  ~FresnelMap();

  void sample();
  static void sampleCB(void * closure, SoSensor * sensor);
};

#endif
