#ifndef TILEMAP_H
#define TILEMAP_H

class SbVec2f;
struct fftwf_plan_s;
typedef float complex[2];

class TileMap {
public:
  TileMap();
  ~TileMap();

  void allocate(int n, int m);
  void deallocate();

  void sample(float amp, float gravity, SbVec2f wind, float scale);
  void shift(float time, float gravity, float scale);
  void transform();

private:
  int n, m;
  float * map;
  complex * f0, * ft, * ht;
  fftwf_plan_s * plan;

  friend class WaveField;
};

#endif
