#version 120

uniform sampler2D displacements;
uniform sampler2D displacements2;

uniform vec2 scales;

varying vec3 position;

void main()
{
  // use vertex as texture coordinate
  gl_TexCoord[0] = gl_Vertex;

  // displace vertex
  gl_Position = gl_Vertex;
  gl_Position.z += texture2D(displacements, scales[0] * gl_TexCoord[0].st)[0];
  
  // look up second displacement - if enabled
  if (bool(scales[1])) gl_Position.z += texture2D(displacements2, scales[1] * gl_TexCoord[0].st)[0];
  
  // store position
  position = gl_Position.xyz;
  gl_Position = gl_ModelViewProjectionMatrix * gl_Position;
}
